declare module 'cf-component-input' {
  import * as React from 'react';

  interface IInputProps {
    type?: 'text' | 'email' | 'number' | 'password' | 'search';
    id?: string;
    name: string;
    value: string;
    onChange: React.ChangeEventHandler<HTMLInputElement>;
    onBlur?: React.ChangeEventHandler<HTMLInputElement>;
    placeholder?: string;
    autoComplete?: string;
    disabled?: boolean;
    invalid?: boolean;
    className?: string;
    inputRef?: (el: HTMLInputElement | null) => void;
  }

  interface ILabeledInputProps {
    label: string;
  }

  class Input extends React.Component<IInputProps, Object> {}
  class InputUnstyled extends React.Component<IInputProps, Object> {}
  class InputTheme extends React.Component<Object, Object> {}
  class LabeledInput extends React.Component<
    IInputProps & ILabeledInputProps,
    Object
  > {}
}
