'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cfStyleContainer = require('cf-style-container');

var _cfComponentBox = require('cf-component-box');

var _ThemedInput = require('./ThemedInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const InputLabel = (0, _cfStyleContainer.createComponent)(({ theme }) => ({
  color: theme.color.dusk,
  textAlign: 'center',
  backgroundColor: theme.color.moonshine,
  borderTop: `1px solid ${theme.color.hail}`,
  borderBottom: `1px solid ${theme.color.hail}`,
  borderLeft: `1px solid ${theme.color.hail}`,
  whiteSpace: 'nowrap',
  marginRight: -1,
  borderTopLeftRadius: 2,
  borderBottomLeftRadius: 2,
  paddingRight: 10,
  paddingLeft: 10,
  marginBottom: '0.75rem',
  fontSize: '0.86667rem',
  display: 'table-cell',
  verticalAlign: 'middle',
  height: theme.inputHeight
}));

const LabeledInput = (_ref) => {
  let { label } = _ref,
      otherProps = _objectWithoutProperties(_ref, ['label']);

  return _react2.default.createElement(
    _cfComponentBox.Box,
    { display: 'flex', width: '100%' },
    label && _react2.default.createElement(
      _cfComponentBox.Box,
      null,
      _react2.default.createElement(
        InputLabel,
        null,
        label
      )
    ),
    _react2.default.createElement(
      _cfComponentBox.Box,
      { flexGrow: 1, position: 'relative', marginLeft: '-1px' },
      _react2.default.createElement(_ThemedInput.ThemedInput, otherProps)
    )
  );
};
LabeledInput.displayName = 'LabeledInput';

LabeledInput.propTypes = {
  label: _propTypes2.default.string
};

exports.default = LabeledInput;